!************************
! SBDBT BLE for RCB
! Copyright (c) 2013 Micono Utilitites
!
!  v1.1 2013/2/18 by Michio Ono
!  v1.2 2013/2/24 by Michio Ono
!  v1.3 2013/2/24 by Michio Ono
!  v1.4 2013/6/9 by Michio Ono
!  v1.5 2013/6/16 by Michio Ono
!  v1.6 2013/9/23 by Michio Ono
!
!************************

Dim isScanning As Integer
Dim isConnected As Integer
Dim isReady As Integer
DIM rcbval(2) AS INTEGER

YES=1
NO=0

!--------------------------
! Define the various UUIDs
serviceUUID$="FFF0"
rcbUUID$="FFF1"

!--------------------------
! Pass an empty array to get all available devices.
DIM uuid(1) AS STRING
DIM sbdbt AS BLEPeripheral
DIM rcbchr AS BLECharacteristic

Dim foundBLE(3) AS BLEPeripheral
Dim foundNum as Integer
Dim scanTime as long
scanWait=2
!BLEscanStart

! Switch to the graphics screen.
System.showGraphics(1,1)
Graphics.setToolsHidden(1)

!=========================
! Device dependent data
!=========================
Dim lrclft,llctop,rrctop,shclft,shctop,ssctop,sscspa
Dim ctrscale,shcscale,sscscale
Dim vertical

height = Graphics.height
width = Graphics.width
if height>width then vertical=YES
!system.orientation: not to use it.

!-------------------
! OnTechBASIC: techBASIC=1, Device=0
! OniPhone: iPhone=1, iPad=0
!-------------------
SysDev=System.Device
Dim OnTechBASIC
Dim OniPhone
if SysDev<256 then OnTechBASIC=YES
if SysDev=0 or SysDev=256 then OniPhone=YES

!=========================
! Initialize GUI
!=========================
Dim msg as Label
Dim cnct as Button,quit as Button
Dim cbw,cbh,qbw as Integer
cbw=30
cbh=24
qbw=60

msg=graphics.newLabel(0,0)
msg.setBackgroundColor(0.7,0.7,0.7)
msg.setAlignment(2)
msg.setText("Find Bluetooth LE...")
cnct=graphics.newButton(0,0,cbw,cbh)
cnct.setbackgroundcolor(1,0,0)
cnct.setGradientColor(1,1,1)
quit=graphics.newButton(0,0)
quit.setTitle("Quit")
quit.setbackgroundcolor(1,1,1)
quit.setGradientColor(0.6,0.6,0.6)
if OnTechBASIC=NO then quit.setFrame(graphics.width-qbw-5,-10000,qbw,22)
!if OnTechBASIC=0 then quit.setHide(1): not work

Dim lrCtl(2) AS ImageView
Dim shCtl(2) as ImageView
Dim ssCtl(2) As ImageView

lrCtl(1)=Graphics.newImageView(0,0)
lrCtl(2)=Graphics.newImageView(0,0)
shCtl(1)=Graphics.newImageView(0,0)
shCtl(2)=Graphics.newImageView(0,0)
ssCtl(1)=Graphics.newImageView(0,0)
ssCtl(2)=Graphics.newImageView(0,0)


!=========================
! Initialize Picture & the position
!=========================
Dim lrbi(2,9) as Image, shbi(2,4) as Image, ssbi(2,2) as Image

Dim lrbx(2,4) !=[[30,130,230,330],[30,130,230,330]]
Dim lrby(2,4) !=[[30,130,230,330],[30,130,230,330]]
Dim shbx(2,3) !=[[0,160,320],[0,160,320]]
Dim shby(2,2) !=[[0,100],[0,100]]
Dim ssbx(2,2) !=[[0,140],[0,140]]
Dim ssby(2,2) !=[[0,40],[0,40]]

kL=1:kR=2
kUU=1:kDD=2:kRR=3:kLL=4:kUR=5:kDR=6:kUL=7:kDL=8:kNN=9
kS1=1:kS2=2:kS3=3:kSN=4
kPP=1:kFF=2

lrVal=[0,0]
lrbn=[[$1,$2,$4,$8,$5,$6,$9,$A],[$10,$20,$40,$100,$50,$60,$110,$120]]

shVal=[0,0]
shbn=[[$200,$400,$600],[$1000,$800,$1800]]

ssVal=[0,0]
ssbn=[[$3],[$C]]

LoadCtrlA(kUU,"a_left_up.png","a_right_up.png")
LoadCtrlA(kDD,"a_left_down.png","a_right_down.png")
LoadCtrlA(kRR,"a_left_right.png","a_right_right.png")
LoadCtrlA(kLL,"a_left_left.png","a_right_left.png")
LoadCtrlA(kUR,"a_left_upright.png","a_right_upright.png")
LoadCtrlA(kDR,"a_left_downright.png","a_right_downright.png")
LoadCtrlA(kUL,"a_left_upleft.png","a_right_upleft.png")
LoadCtrlA(kDL,"a_left_downleft.png","a_right_downleft.png")
LoadCtrlA(kNN,"a_left_nutral.png","a_right_nutral.png")

LoadCtrlB(kS1,"a_Shift_Left_L1.png","a_Shift_Right_R2.png")
LoadCtrlB(kS2,"a_Shift_Left_L2.png","a_Shift_Right_R1.png")
LoadCtrlB(kS3,"a_Shift_Left_L12.png","a_Shift_Right_R12.png")
LoadCtrlB(kSN,"a_Shift_Left_nutral.png","a_Shift_Right_nutral.png")

LoadCtrlC(kPP,"start_push.png","select_push.png")
LoadCtrlC(kFF,"start_free.png","select_free.png")

setUpGUI

!System.wait(1)
BLEscanStart

!===============================
! Load control pictures
!===============================
SUB LoadCtrlA(j as integer, ln as string, rn as string)
  lrbi(kL,j)=System.NewImage
  lrbi(kL,j).Load(ln)
  lrbi(kR,j)=System.NewImage
  lrbi(kR,j).Load(rn)
End Sub

SUB LoadCtrlB(j as integer, ln as string, rn as string)
  shbi(kL,j)=System.NewImage
  shbi(kL,j).Load(ln)
  shbi(kR,j)=System.NewImage
  shbi(kR,j).Load(rn)
End SUB

SUB LoadCtrlC(j as integer, sa as string, sb as string)
  ssbi(kL,j)=System.NewImage
  ssbi(kL,j).Load(sa)!select
  ssbi(kR,j)=System.NewImage
  ssbi(kR,j).Load(sb)!start
End SUB


!===============================
! touch evevts
!===============================
SUB touchesBegan (e AS EVENT)
  drawController(e)
End SUB

SUB touchesmoved(e as event)
  drawController(e)
end SUB

SUB touchesEnded (e AS EVENT)
  n=0: msg.setText("")
  for i=1 to 2
    lrcbp(i)=kNN:lrCtl(i).setImage(lrbi(i,kNN),0)
    shcbn(i)=kSN:shCtl(i).setImage(shbi(i,kSN),0)
    sscbn(i)=kFF:ssCtl(i).setImage(ssbi(i,kFF),0)
  next
  writeRCB(0)
End SUB

SUB nullEvent(time as double)
  if height<>Graphics.height and width<>Graphics.width then
    height = Graphics.height
    width = Graphics.width
    vertical=0
    if height>width then vertical=YES
    setUpGUI
  end if
  if isConnected=NO and isScanning=YES and scantime>0 then BLEConnect
end SUB

SUB touchUpInside (ctrl AS Button, time AS DOUBLE)
  if ctrl = quit then
    BLEdisconnect
    STOP
  else if ctrl=cnct then
    if isConnected=0 then
      !LogMsg("Start BLE Scanning...")
      BLEscanStart
    else
      LogMsg("The connection was lost.")
      BLEdisconnect
    end if
  end if
END SUB


!===============================
! Draw Controller
!===============================
SUB drawController(e as Event)
  lrVal(1)=0: lrVal(2)=0
  lrcbn(1)=kNN: lrcbn(2)=kNN
  shVal(1)=0: shVal(2)=0
  shcbn(1)=kSN: shcbn(2)=kSN
  ssVal(1)=0: ssVal(2)=0
  sscbn(1)=kFF: sscbn(2)=kFF
  
  w=e.Where
  n=ubound(w,1)
  
  Dim x,y as integer
  for i=1 to n
    x=w(i,1)
    y=w(i,2)
    for j=1 to 2
      !=======
      if y>lrby(j,2) and y<lrby(j,3) then
        if x>lrbx(j,1) and x<lrbx(j,2) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,4) !$0008
        else if x>lrbx(j,3) and x<lrbx(j,4) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,3) !$0004
        end if
      else if x>lrbx(j,2) and x<lrbx(j,3) then
        if y>lrby(j,1) and y<lrby(j,2) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,1) !$0001
        else if y>lrby(j,3) and y<lrby(j,4) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,2) !$0002
        end if
      else if x>lrbx(j,1) and x<lrbx(j,2) then
        if y>lrby(j,1) and y<lrby(j,2) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,7) !$0009
        else if y>lrby(j,3) and y<lrby(j,4) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,8) !$000A
        end if
      else if x>lrbx(j,3) and x<lrbx(j,4) then
        if y>lrby(j,1) and y<lrby(j,2) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,5) !$0005
        else if y>lrby(j,3) and y<lrby(j,4) then
          lrVal(j)=lrVal(j) BitOr lrbn(j,6) !$0006
        end if
      end if
      !=======
      if y>shby(j,1) and y<shby(j,2) then
        if x>shbx(j,1) and x<shbx(j,2) then
          shVal(j)=shVal(j) BitOr shbn(j,1)
        else if x>shbx(j,2) and x<shbx(j,3) then
          shVal(j)=shVal(j) BitOr shbn(j,2)
        end if
      end if
      !=======
      if y>ssby(j,1) and y<ssby(j,2) then
        if x>ssbx(j,1) and x<ssbx(j,2) then
          ssVal(j)=ssVal(j) BitOr ssbn(j,1)
        end if
      end if
      !=======
    next
  next
  
  for i=1 to 2
    Select Case lrVal(i)
      Case lrbn(i,kUU)
        lrcbn(i)=kUU
      Case lrbn(i,kDD)
        lrcbn(i)=kDD
      Case lrbn(i,kRR)
        lrcbn(i)=kRR
      Case lrbn(i,kLL)
        lrcbn(i)=kLL
      Case lrbn(i,kUR)
        lrcbn(i)=kUR
      Case lrbn(i,kDR)
        lrcbn(i)=kDR
      Case lrbn(i,kUL)
        lrcbn(i)=kUL
      Case lrbn(i,kDL)
        lrcbn(i)=kDL
    End Select
    if lrcbn(i)<>lrcbp(i) then
      lrCtl(i).setImage(lrbi(i,lrcbn(i)),0)
      lrcbp(i)=lrcbn(i)
    end if
    
    Select Case shVal(i)
      Case shbn(i,kS1)
        shcbn(i)=kS1
      Case shbn(i,kS2)
        shcbn(i)=kS2
      Case shbn(i,kS3)
        shcbn(i)=kS3
    End Select
    if shcbn(i)<>shcbp(i) then
      shCtl(i).setImage(shbi(i,shcbn(i)),0)
      shcbp(i)=shcbn(i)
    end if
    
    Select Case ssVal(i)
      Case ssbn(i,kPP)
        sscbn(i)=kPP
    End Select
    if sscbn(i)<>sscbp(i) then
      ssCtl(i).setImage(ssbi(i,sscbn(i)),0)
      sscbp(i)=sscbn(i)
    end if
    
  next
  
  Dim s as string
  for i=1 to n
    s=s & "(" & str(w(i,1)) & ", " & str(w(i,2)) & ")"
    if i<n then s=s & ", "
  next
  
  rcb=lrVal(1) BitOr lrVal(2) BitOr shVal(1) BitOr shVal(2) BitOr ssVal(1) BitOr ssVal(2)
  msg.setText(">" & str(rcb) & "<  " & s)
  writeRCB(rcb)
  
END SUB


!===============================
! Look to see if this is an iPhone or iPad, 
! and set the GUI up as appropriate.
!===============================
SUB setUpGUI()
  ! Get the size of the display.
  height = Graphics.height
  width = Graphics.width
  IF OniPhone then 
    setUpiPhoneGUI
  ELSE
    setUpiPadGUI
  END IF
  ! GUI parts
  msg.setFrame(0,graphics.height-30,graphics.width,30)
  ! default Controller position
  lrbx=[[30,130,230,330],[30,130,230,330]]
  lrby=[[30,130,230,330],[30,130,230,330]]
  shbx=[[0,160,320],[0,160,320]]
  shby=[[0,100],[0,100]]
  ssbx=[[0,140],[0,140]]
  ssby=[[0,40],[0,40]]
  !for i=0 to height-1 step 10
  !graphics.setColor(0.5,0.5,0.5)
  !graphics.drawline(0,i,width,i)
  !next
  !for i=0 to width-1 step 10
  !graphics.setColor(0.5,0.5,0.5)
  !graphics.drawline(i,0,i,height)
  !next
  !for i=0 to height-1 step 50
  !graphics.setColor(1,0,0)
  !graphics.drawline(0,i,width,i)
  !next
  !for i=0 to width-1 step 50
  !graphics.setColor(1,0,0)
  !graphics.drawline(i,0,i,height)
  !next
  !for i=0 to height-1 step 100
  !graphics.setColor(0,0,1)
  !graphics.drawline(0,i,width,i)
  !next
  !for i=0 to width-1 step 100
  !graphics.setColor(0,0,1)
  !graphics.drawline(i,0,i,height)
  !next
  lcw=lrbi(kL,kNN).width*ctrscale
  lch=lcw
  rcw=lcw
  rch=lcw
  rsw=shbi(kR,kSN).width*shcscale
  rsh=shbi(kR,kSN).height*shcscale
  ssw=ssbi(1,kFF).width*sscscale
  ssh=ssbi(1,kFF).height*sscscale
  graphics.setColor(0.6,0.6,0.6)
  graphics.fillrect(0,shctop,width,10000)
  for i=1 to 4
    lrbx(1,i)=lrclft+lrbx(1,i)*ctrscale
    lrbx(2,i)=width-lrclft-rcw+lrbx(2,i)*ctrscale
    lrby(1,i)=llctop+lrby(1,i)*ctrscale
    lrby(2,i)=rrctop+lrby(2,i)*ctrscale
  next
  for i=1 to 3
    shbx(1,i)=shclft+shbx(1,i)*shcscale
    shbx(2,i)=width-shclft-rsw+shbx(2,i)*shcscale
  next
  for i=1 to 2
    shby(1,i)=shctop+shby(2,i)*shcscale
    shby(2,i)=shctop+shby(2,i)*shcscale
  next
  for i=1 to 2
    ssbx(1,i)=width/2+sscspa+ssbx(1,i)*sscscale
    ssbx(2,i)=width/2-sscspa-ssbx(2,2)*sscscale+ssbx(2,i)*sscscale
    ssby(1,i)=ssctop+ssby(1,i)*sscscale
    ssby(2,i)=ssctop+ssby(2,i)*sscscale
  next
  lrCtl(1).setFrame(lrclft,llctop,lcw,lch)
  lrCtl(2).setFrame(width-lrclft-rcw,rrctop,rcw,rch)
  shCtl(1).setFrame(shclft,shctop,rsw,rsh)
  shCtl(2).setFrame(width-shclft-rsw,shctop,rsw,rsh)
  ssCtl(1).setFrame(width/2+sscspa,ssctop,ssw,ssh)
  ssCtl(2).setFrame(width/2-sscspa-ssw,ssctop,ssw,ssh)
  graphics.setColor(0.8,0.8,0.8)
  graphics.filloval(lrclft,llctop,lcw,lch)
  graphics.filloval(width-lrclft-rcw,rrctop,rcw,rch)
  for i=1 to 2
    lrCtl(i).setImage(lrbi(i,kNN),0)
    shCtl(i).setImage(shbi(i,kSN),0)
    ssCtl(i).setImage(ssbi(i,kFF),0)
  next
END SUB

!===============================
SUB setUpiPhoneGUI()
  ctrscale=0.6
  shcscale=0.48
  sscscale=0.5
  if (height=480 and width=320) or (height=320 and width=480) then ctrscale=0.5
    lrclft=10
    llctop=(height+shbi(kR,kSN).height*shcscale-20-lrbi(kL,kNN).height*ctrscale)/2
    rrctop=llctop
    shctop=0
    shclft=0
    ssctop=llctop
    sscspa=10
    if vertical=0 then
      shcscale=0.6
      if OnTechBASIC then
        quit.setFrame((graphics.width-qbw)/2,130,qbw,22)
      else
        quit.setFrame(graphics.width-65,-10000,qbw,22)
      end if
      cnct.setFrame((width-cbw)/2,rrctop+(height-rrctop)/2,cbw,cbh)
  else
    llctop=height-lrbi(kL,kNN).width*ctrscale-40
    rrctop=shctop+shbi(kR,kSN).height*shcscale+10
    lrclft=(width-lrbi(kL,kNN).width*ctrscale)/2
    ssctop=(height-shctop+shbi(kR,kSN).height*shcscale-30-ssbi(kL,kFF).height*sscscale)/2
    sscspa=40
    if OnTechBASIC then
      quit.setFrame(graphics.width-qbw-5,graphics.height-60,qbw,22)
    else
      quit.setFrame(graphics.width-qbw-5,-10000,qbw,22)
    end if
    cnct.setFrame((width-cbw)/2,ssctop,cbw,cbh)
  end if
  
End SUB

!===============================
SUB setUpiPadGUI()
  ctrscale=0.8
  shcscale=0.8
  sscscale=0.6
  lrclft=20
  llctop=height-lrbi(kL,kNN).width*ctrscale-50
  rrctop=llctop
  shclft=20
  shctop=height-lrbi(kL,kNN).width*ctrscale-50-100
  ssctop=llctop
  sscspa=10
  
  if OnTechBASIC then
    quit.setFrame((graphics.width-qbw)/2,graphics.height-260,qbw,22)
  else
    quit.setFrame((graphics.width/2-qbw)/2,-10000,qbw,22)
  end if
  cnct.setFrame((width-cbw)/2,rrctop+(height-rrctop)/2,cbw,cbh)

End SUB

!===============================
Sub LogMsg(s as string)
  msg.setText(s)
End Sub

!===============================
! Initialize
!===============================
Sub initializePreferVariables()
  isReady=NO
  isConnected=NO
  isScanning=NO
End Sub

!==========================
!%%%%%%%%%%%%%%%%%%%
! Bluetooth LE
!%%%%%%%%%%%%%%%%%%%
!==========================

!===============================
Sub ConnectStatusIndicator()
  if isConnected=NO then
    isReady=NO
    cnct.setbackgroundcolor(1,0,0)
    LogMsg("The connection was lost.")
  else
    if isReady then
      cnct.setbackgroundcolor(0,1,0)
    else
      cnct.setbackgroundcolor(1,0,0)
    end if
  end if
End Sub

!--------------------------
! Called when a peripheral is found. If it is a target device, we
! initiate a connection to is and stop scanning for peripherals.
!
! Parameters:
!    time - The time when the peripheral was discovered.
!    peripheral - The peripheral that was discovered.
!    services - List of services offered by the device.
!    advertisements - Advertisements (information provided by the
!        device without the need to read a service/characteristic)
!    rssi - Received Signal Strength Indicator
!---------------------------
SUB BLEDiscoveredPeripheral(time AS DOUBLE, peripheral AS BLEPeripheral,services() AS STRING, advertisements(,) AS STRING, rssi AS SINGLE)
  LogMsg("Found " & peripheral.bleName & " UUID = " & peripheral.uuid)
  if foundNum<3 then
    foundNum=foundNum+1
    foundBLE(foundNum)=peripheral
    scanTime=system.ticks
  end if
END SUB

!---------------------------
! Called to report information about the connection status of the
! peripheral or to report that services have been discovered.
!
! Parameters:
!    time - The time when the information was received.
!    peripheral - The peripheral.
!    kind - The kind of call. One of
!        1 - Connection completed
!        2 - Connection failed
!        3 - Connection lost
!        4 - Services discovered
!    message - For errors, a human-readable error message.
!    err - If there was an error, the Apple error number. If there
!        was no error, this value is 0.
!---------------------------
SUB BLEPeripheralInfo (time AS DOUBLE, peripheral AS BLEPeripheral, kind AS INTEGER, msg AS STRING, err AS LONG)
  IF kind = 1 THEN
    LogMsg("Connected to " & peripheral.bleName)
    isConnected=YES !connectStatus=sbdbt.IsConnected
    ConnectStatusIndicator
    peripheral.discoverServices(uuid)
    
  ELSE IF kind = 2 OR kind = 3 THEN
    LogMsg("The connection was lost.")
    isConntected=NO
    isReady=NO
    ConnectStatusIndicator
    
  ELSE IF kind = 4 THEN
    ! Services were found. If it is the main service, begin discovery
    ! of its characteristics.
    DIM availableServices(1) AS BLEService
    availableServices = peripheral.services
    FOR a = 1 TO UBOUND(availableServices, 1)
      LogMsg("Found service "& availableServices(a).UUID)
      IF availableServices(a).UUID = serviceUUID$ THEN
        peripheral.discoverCharacteristics(uuid, availableServices(a))
      END IF
    NEXT
    
  END IF
END SUB

!-----------------------------
! Called to report information about a characteristic or included
! services for a service. If it is one we are interested in, start
! handling it.
!
! Parameters:
!    time - The time when the information was received.
!    peripheral - The peripheral.
!    service - The service whose characteristic or included
!        service was found.
!    kind - The kind of call. One of
!        1 - Characteristics found
!        2 - Included services found
!    message - For errors, a human-readable error message.
!    err - If there was an error, the Apple error number. If there
!        was no error, this value is 0.
!---------------------------
SUB BLEServiceInfo (time AS DOUBLE, peripheral AS BLEPeripheral, service AS BLEService, kind AS INTEGER, msg AS STRING, err AS LONG)
  IF kind = 1 THEN
    DIM characteristics(1) AS BLECharacteristic
    characteristics = service.characteristics
    FOR i = 1 TO UBOUND(characteristics, 1)
      LogMsg("Found characteristic " & str(i) & ": " & characteristics(i).uuid)
      if service.uuid=serviceUUID$ then
        Select Case characteristics(i).uuid
          Case rcbUUID$
            rcbchr=characteristics(i)
        End Select
      end if
    NEXT
    
    IF service.uuid=serviceUUID$ then
      if rcbchr<>NULL then
        isReady=YES
        LogMsg("Connected... Control OK!")
        ConnectStatusIndicator
      end if
    END IF
    
  END IF
END SUB

!---------------------------
! Called to return information from a characteristic.
!
! Parameters:
!    time - The time when the information was received.
!    peripheral - The peripheral.
!    characteristic - The characteristic whose information
!        changed.
!    kind - The kind of call. One of
!        1 - Called after a discoverDescriptors call.
!        2 - Called after a readCharacteristics call.
!        3 - Called to report status after a writeCharacteristics
!            call.
!    message - For errors, a human-readable error message.
!    err - If there was an error, the Apple error number. If there
!        was no error, this value is 0.
!
!---------------------------
SUB BLECharacteristicInfo (time AS DOUBLE, peripheral AS BLEPeripheral, characteristic AS BLECharacteristic, kind AS INTEGER, msg AS STRING, err AS LONG)
  IF kind = 2 THEN
    DIM value(1) AS INTEGER
    LogMsg("Value for characteristic ") ! & characteristic.uuid " = ")
    value = characteristic.value
    SELECT CASE characteristic.uuid
      CASE rcbUUID$
        FOR i = 1 TO UBOUND(value, 1)
          LogMsg( characteristic.uuid & " = " & CHR(value(i)) )
        NEXT
        LogMsg(" ")
      CASE ELSE
        !PRINT "Unexpected UUID "; characteristic.uuid
    END SELECT
  ELSE IF kind = 3 THEN
    !Write response recieved.
    SELECT CASE characteristic.uuid
      CASE rcbUUID$
        peripheral.readCharacteristic(characteristic)
      CASE ELSE
        !LogMsg "Unexpected UUID "; characteristic.uuid
    END SELECT
  END IF
END SUB

!---------------------------
Sub BLEscanStart()
  LogMsg("Start BLE Scanning...")
  isScanning=YES
  isConntected=NO
  isReady=NO
  foundNum=0
  scanTime=System.Ticks
  BLE.startBLE
  BLE.startScan(uuid)
End Sub

!---------------------------
Sub BLEConnect()
  cnct.setbackgroundcolor(1,rnd(1),0)
  if system.ticks-scantime>scanWait then
    !isScanning=NO
    scantime=0
    LogMsg("Stopping Scan.")
    BLE.stopScan
    if foundNum>0 then
      Dim pn(3) as String
      for i=1 to foundnum
        pn(i)=foundBLE(i).bleName & " / " & foundBLE(i).uuid
      next
      n=foundnum
      if foundnum>1 then 
        n=graphics.showAlert("Connect","Select Peripheral","Cancel",pn(1),pn(2),pn(3))-1
      end if
      Select Case n
        case 0:
          BLE.stopBLE
          ConnectStatusIndicator
        case else
          LogMsg("Connecting...")
          cnct.setbackgroundcolor(1,1,0)
          sbdbt = foundBLE(n)
          BLE.connect(sbdbt)
      End Select
    end if
  end if
End Sub

!---------------------------
Sub BLEdisconnect()
  BLE.disconnect(sbdbt)
  BLE.stopBLE
  isScanning=NO
  isConnected=NO
  isReady=NO
  rcbchr=NULL
  sbdbt=NULL
  ConnectStatusIndicator
End Sub

!---------------------------
Sub writeRCB(n as integer)
  if isReady then
    if rcbchr<>NULL then
      rcbval=[n>>8 bitand $FF,n bitand $FF]
      sbdbt.writeCharacteristic(rcbchr, rcbval)
    end if
  end if
End Sub

!---------------------------